"use strict";

const argx = require('argx'),
    assert = require('assert'),
    findout = require('findout'),
    apemanfile = require('apemanfile'),
    Promise = require('apemanpromise'),
    coz = require('coz');

let apemanfileDocBud = require('./bud/apemanfile_doc_bud');

/** @lends apemanDoc */
function apemanDoc(options) {
    let args = argx(arguments);
    options = args.pop('object') || {};

    let dest = options.out || 'doc/apdoc.md';

    let asis = !!options.asis,
        $ctx = options.$ctx || options.ctx;

    if ($ctx && typeof($ctx) === 'string') {
        $ctx = findout($ctx);
    }

    let configuration = apemanfile(options.configuration, {
        $preloadedCtx: $ctx,
        $preloadedProto: asis ? [] : null
    });
    let bud = apemanfileDocBud(configuration);
    bud.path = dest || bud.path;

    return new Promise((resolve, reject) =>
        coz.render(bud, {
            prefix: 'apeman-doc'
        }, err => err ? reject(err) : resolve())
    )
}


module.exports = apemanDoc;
