/**
 * @function appsData
 */

"use strict";

const textconv = require('textconv'),
    arraysort = require('arraysort');

/** @lends appsData */
function appsData($apps, $notes) {
    if (!$apps) {
        return null;
    }
    let stringCompare = arraysort.stringCompare();
    return Object.keys($apps).sort(stringCompare).map((name) => {
        let app = $apps[name],
            $note = $notes && $notes['$apps.' + name];
        let desc = $note || app.$desc || app.$description || JSON.stringify(app) || '';
        return {
            name: name,
            desc: textconv.chop(textconv.inline(desc), 80, {ellipsis: true})
        }
    });
}

module.exports = appsData;
