/**
 * @function tasksData
 */

"use strict";

const textconv = require('textconv'),
    arraysort = require('arraysort');

/** @lends tasksData */
function tasksData($tasks, $notes) {
    if (!$tasks) {
        return null;
    }
    let stringCompare = arraysort.stringCompare();
    return Object.keys($tasks).sort(stringCompare).map((name) => {
        let task = $tasks[name],
            $note = $notes && $notes['$tasks.' + name];
        let desc = $note || task.$desc || task.$description || JSON.stringify(task) || '';
        return {
            name: name,
            desc: textconv.chop(textconv.inline(desc), 80, {ellipsis: true})
        }
    });
}

module.exports = tasksData;
