/**
 * @function tmplsData
 */

"use strict";

const textconv = require('textconv'),
    arraysort = require('arraysort');

/** @lends tmplsData */
function tmplsData($tmpls) {
    if (!$tmpls) {
        return null;
    }
    let stringCompare = arraysort.stringCompare();
    return Object.keys($tmpls).sort(stringCompare)
        .filter(path => !!$tmpls[path])
        .map(path => {
            let tmpl = $tmpls[path];
            return {
                path: path,
                force: tmpl.force,
                mode: tmpl.mode,
                get tmpl() {
                    let value = textconv.inline(tmpl.tmpl);
                    return textconv.chop(value, 40, {ellipsis: true});
                },
                get data() {
                    let value = textconv.inline(JSON.stringify(tmpl.data || {}));
                    return textconv.chop(value, 40, {ellipsis: true});
                }

            }
        });
}


module.exports = tmplsData;
