/**
 * @function wtchsData
 */

"use strict";

const textconv = require('textconv'),
    arraysort = require('arraysort');

/** @lends wtchsData */
function wtchsData($wchs, $notes) {
    if (!$wchs) {
        return null;
    }
    let stringCompare = arraysort.stringCompare();
    return Object.keys($wchs).sort(stringCompare).map((name) => {
        let watch = $wchs[name],
            $note = $notes && $notes['$wchs.' + name];
        let desc = $note || watch.$desc || watch.$description || JSON.stringify(watch) || '';
        return {
            name: name,
            desc: textconv.chop(textconv.inline(desc), 80, {ellipsis: true})
        }
    });
}

module.exports = wtchsData;
